//-------------------------------------------------------------
// Hidden Conditional Random Field Library - Implementation of
// latent label (shared) features
//
//	Added June 2014 by Michael Soukup

#ifndef SHARED_FEATURES_H
#define SHARED_FEATURES_H

#include "featuregenerator.h"


class SharedFeatures : public FeatureType
{
public:
	SharedFeatures();

	void init(const DataSet& dataset, const Model& m);
	void getFeatures(featureVector& listFeatures, DataSequence* X, Model* m, int nodeIndex, int prevNodeIndex, int seqLabel = -1);
	void computeFeatureMask(iMatrix& matFeautureMask, const Model& m);
	bool isEdgeFeatureType();
	
	void getAllFeatures(featureVector& listFeatures, Model* m, int nbRawFeatures);
};

#endif 
