#!/usr/bin/env python
# -*- coding: utf-8 -*-

import pygame, time, sys

try:
    x0, y0 = sys.argv[1].split(',')
    x0 = int(x0)
    y0 = int(y0)
except Exception:
    print "Usage: %s [x0,y0]" % sys.argv[0]
    sys.exit(1)


KEYMAP = {
	pygame.K_UP: (0,-1),
	pygame.K_DOWN: (0,1),
	pygame.K_LEFT: (-1,0),
	pygame.K_RIGHT: (1,0)
}
SCREEN_DIM = (800, 600)
R = 5

pygame.init()
screen = pygame.display.set_mode(SCREEN_DIM)
pygame.display.set_caption("ErrP path generator")
font = pygame.font.SysFont(None, 24)
clock = pygame.time.Clock()

def _disptxt(s_arr, col):
	global screen, font
	screen.fill((255, 255, 255))
	for i,s in enumerate(s_arr):
		screen.blit(font.render(s, True, col), (10, 10 + i*20))
	pygame.display.flip()


pos = (x0, y0)
prev_pos = pos
path = []
vel = 10

running = True
while running:
    pressed = pygame.key.get_pressed()
    for e in pygame.event.get():
        if e.type == pygame.QUIT or pressed[pygame.K_ESCAPE]:
            running = False

    cmd = (0,0)
    for k in KEYMAP.keys():
        if pressed[k]:
            cmd = KEYMAP[k]

    x, y = map(sum, zip(pos, cmd))
    x = max(0, min(x, SCREEN_DIM[0]))
    y = max(0, min(y, SCREEN_DIM[1]))
    pos = (x, y)
    if pos != prev_pos:
        path.append(pos)

    screen.fill((255,255,255))
    for p in path:
        pygame.draw.circle(screen, (50,50,50), map(int, p), R-2)
    pygame.draw.circle(screen, (255,0,0), map(int, pos), R)
    pygame.display.flip()

    prev_pos = pos
    clock.tick(60)

_disptxt(["Cleaning up..."], (0,0,0))
pygame.quit()

if raw_input("Save path? (y/n) ") == "y":
    fname = raw_input("Filename: ")
    f = open(fname, 'a')
    f.write(str(path) + '\n')
    f.flush()
    f.close()

