function featureSubset = featureSelectionCRF(features, sid)
% Features in: [C3_alpha, C3_sigma, C3_beta, Cz_alpha, ...]' x N
% Channel list: C3, Cz, C4, CP1, CP2, P3, Pz, P4.
%
% Returns a subset of features = [C3_alpha, C3_sigma, C3_beta, Cz_alpha, ...]' x N

N_BANDS = 3;

switch sid
    case 1
        featureSubset = zeros(4, size(features, 2));
        featureSubset(1, :) = features(0*N_BANDS + 2, :); % C3 sigma
        featureSubset(2, :) = features(0*N_BANDS + 3, :); % C3 beta
        featureSubset(3, :) = features(3*N_BANDS + 1, :); % CP1 alpha
        featureSubset(4, :) = features(3*N_BANDS + 2, :); % CP1 sigma
    case 2
        featureSubset = zeros(5, size(features, 2));
        featureSubset(1, :) = features(0*N_BANDS + 1, :); % C3 alpha
        featureSubset(2, :) = features(1*N_BANDS + 3, :); % Cz beta
        featureSubset(3, :) = features(2*N_BANDS + 1, :); % C4 alpha
        featureSubset(4, :) = features(2*N_BANDS + 3, :); % C4 beta
        featureSubset(5, :) = features(7*N_BANDS + 3, :); % P4 beta
    case 3
        featureSubset = zeros(3, size(features, 2));
        featureSubset(1, :) = features(0*N_BANDS + 1, :); % C3 alpha
        featureSubset(2, :) = features(0*N_BANDS + 2, :); % C3 sigma
        featureSubset(3, :) = features(6*N_BANDS + 3, :); % Pz beta
end
