function featureSubset = featureSelectionSHDCRF(features, sid)
% Features in: [C3_alpha, C3_sigma, C3_beta, Cz_alpha, ...]' x N
% Channel list: C3, Cz, C4, CP1, CP2, P3, Pz, P4.
%
% Returns a subset of features = [C3_alpha, C3_sigma, C3_beta, Cz_alpha, ...]' x N

% NB! Currently same selection as in LDCRF. See Saa et al

N_BANDS = 3;

switch sid
    case 1
        featureSubset = zeros(4, size(features, 2));
        featureSubset(1, :) = features(0*N_BANDS + 1, :); % C3 alpha
        featureSubset(2, :) = features(0*N_BANDS + 3, :); % C3 beta
        featureSubset(3, :) = features(3*N_BANDS + 1, :); % CP1 alpha
        featureSubset(4, :) = features(5*N_BANDS + 2, :); % P3 sigma
    case 2
        featureSubset = zeros(6, size(features, 2));
        featureSubset(1, :) = features(0*N_BANDS + 1, :); % C3 alpha
        featureSubset(2, :) = features(2*N_BANDS + 1, :); % C4 alpha
        featureSubset(3, :) = features(2*N_BANDS + 2, :); % C4 sigma
        featureSubset(4, :) = features(2*N_BANDS + 3, :); % C4 beta
        featureSubset(5, :) = features(3*N_BANDS + 2, :); % CP1 sigma
        featureSubset(6, :) = features(7*N_BANDS + 3, :); % P4 beta
    case 3
        featureSubset = zeros(2, size(features, 2));
        featureSubset(1, :) = features(0*N_BANDS + 2, :); % C3 sigma
        featureSubset(2, :) = features(4*N_BANDS + 3, :); % CP2 beta
end