function features = featuresAvrgBP(x)
% Computes average BP of alpha, sigma and beta bands.
% Returns features = [C3_alpha, C3_sigma, C3_beta, Cz_alpha, ...]' x N

N_CHAN = 8;
N_FREQS = 12;

x_offset = 0;
features = zeros(N_CHAN*3, size(x, 2));
for k=1:N_CHAN
    f_offset = (k-1)*3;    
    features(f_offset+1, :) = mean(  x((x_offset+1):(x_offset+3), :)  );   % alpha (8-12Hz)
    features(f_offset+2, :) = mean(  x((x_offset+3):(x_offset+5), :)  );   % sigma (12-16Hz)
    features(f_offset+3, :) = mean(  x((x_offset+6):(x_offset+10), :)  );  % beta (18-26Hz)
    x_offset = x_offset + N_FREQS;
end
