function result = getResult(ll, labels)

[numClasses, N] = size(ll);
predictedLabels = zeros(1,N);
correctSamples = 0;

for i=1:N
    [val, idx] = max(ll(:,i));
    predictedLabels(i) = idx-1;
    if predictedLabels(i) == labels(i),
        correctSamples = correctSamples + 1;
    end
end

result.numClasses = numClasses;
result.N = N;
result.predictedLabels = predictedLabels;
result.labels = labels;
result.correctSamples = correctSamples;
result.successRate = correctSamples*100/N;