diary outputCRF.txt;

loadDataCRF;
subjectResultCRF = {};         % Container that holds results for all subjects
sid = 0;                   % If 0, we do all subjects

%paramsData.weightsPerSequence = ones(1,128) ;
%paramsData.factorSeqWeights = 1;
paramsNodCRF.modelType = 'crf'; % 'crf','hcrf','ghcrf', 'ldcrf'
paramsNodCRF.optimizer = 'bfgs'; % 'cg', 'bfgs', 'lbfgs'. bfgs: limited newton, cg: conjugate gradient
paramsNodCRF.windowSize = 0; % 0: only current time sample. 1+: neighbour samples are concated with current sample to create the final feature vector
paramsNodCRF.maxIterations = 300;
paramsNodCRF.caption = 'CRF';
paramsNodCRF.regFactor = 10;
paramsNodCRF.rocRange = 0:0.01:1;
paramsNodCRF.debugLevel = 2;
paramsNodCRF.nbIterations = 1;
paramsNodCRF.computeTrainningError = 1;
paramsNodCRF.rangeWeights = [0 0];
paramsNodCRF.normalizeWeights = 1;

for i=1:3
    if sid == 0 || sid == i
        params = paramsNodCRF;
        [model, stats] = train(subjectData{i}.trainSeqs, subjectData{i}.trainLabels, params);
        [ll, labels] = test(model, subjectData{i}.testSeqs, subjectData{i}.testLabels);
        result = getResult(ll{1,1}, labels{1,1});
        
        subjectResultCRF{i}.params = params;
        subjectResultCRF{i}.model = model;
        subjectResultCRF{i}.stats = stats;
        subjectResultCRF{i}.ll = ll;
        subjectResultCRF{i}.labels = labels;
        subjectResultCRF{i}.result = result;
        plotResult(result);
    end
end

diary off;

