diary outputLDCRF.txt;

loadDataLDCRF;
subjectResultLDCRF = {};         % Container that holds results for all subjects
sid = 0;                   % If 0, we do all subjects


%paramsData.weightsPerSequence = ones(1,128) ;
%paramsData.factorSeqWeights = 1;
paramsNodLDCRF.modelType = 'ldcrf'; % 'crf','hcrf','ghcrf', 'ldcrf'
paramsNodLDCRF.optimizer = 'bfgs'; % 'cg', 'bfgs', 'lbfgs'. bfgs: limited newton, cg: conjugate gradient
paramsNodLDCRF.windowSize = 0; % 0: only current time sample. 1+: neighbour samples are concated with current sample to create the final feature vector
paramsNodLDCRF.maxIterations = 300;
paramsNodLDCRF.caption = 'LDCRF';
paramsNodLDCRF.regFactor = 10;
paramsNodLDCRF.rocRange = 0:0.01:1;
paramsNodLDCRF.debugLevel = 1;
paramsNodLDCRF.nbIterations = 1;
paramsNodLDCRF.computeTrainningError = 1;
paramsNodLDCRF.rangeWeights = [0 0];
paramsNodLDCRF.nbHiddenStates = 2; % Per states

for i=1:3
    if sid == 0 || sid == i
        fprintf('subject%d\n', i);
        
        params = paramsNodLDCRF;
        [model, stats] = train(subjectData{i}.trainSeqs, subjectData{i}.trainLabels, params);
        [ll, labels] = test(model, subjectData{i}.testSeqs, subjectData{i}.testLabels);
        result = getResult(ll{1,1}, labels{1,1});
        
        subjectResultLDCRF{i}.params = params;
        subjectResultLDCRF{i}.model = model;
        subjectResultLDCRF{i}.stats = stats;
        subjectResultLDCRF{i}.ll = ll;
        subjectResultLDCRF{i}.labels = labels;
        subjectResultLDCRF{i}.result = result;
        plotResult(result);
    end
end

diary off;

