diary outputSHDCRF.txt;

loadDataSHDCRF;
subjectResultSHDCRF = {};         % Container that holds results for all subjects
sid = 0;                   % If 0, we do all subjects


%paramsData.weightsPerSequence = ones(1,128) ;
%paramsData.factorSeqWeights = 1;
paramsNodSHDCRF.modelType = 'shdcrf'; % 'crf','hcrf','ghcrf', 'ldcrf'
paramsNodSHDCRF.optimizer = 'bfgs'; % 'cg', 'bfgs', 'lbfgs'. bfgs: limited newton, cg: conjugate gradient
paramsNodSHDCRF.windowSize = 0; % 0: only current time sample. 1+: neighbour samples are concated with current sample to create the final feature vector
paramsNodSHDCRF.maxIterations = 300;
paramsNodSHDCRF.caption = 'SHDCRF';
paramsNodSHDCRF.regFactor = 10;
paramsNodSHDCRF.rocRange = 0:0.01:1;
paramsNodSHDCRF.debugLevel = 1;
paramsNodSHDCRF.nbIterations = 1;
paramsNodSHDCRF.computeTrainningError = 1;

%paramsNodSHDCRF.initWeights = [weights];
paramsNodSHDCRF.rangeWeights = [-0.5 0.5];
paramsNodSHDCRF.weightsInitType = 'RANDOM';
paramsNodSHDCRF.sparsityFactor = 0.1;
paramsNodSHDCRF.nbHiddenStates = 5; % 2 states per label

for i=1:3
    if sid == 0 || sid == i
        fprintf('subject%d\n', i);
        params = paramsNodSHDCRF;
        [model, stats] = train(subjectData{i}.trainSeqs, subjectData{i}.trainLabels, params);
        
        % dont test immidately
        [ll, labels] = test(model, subjectData{i}.testSeqs, subjectData{i}.testLabels);
        result = getResult(ll{1,1}, labels{1,1});
        
        subjectResultSHDCRF{i}.params = params;
        subjectResultSHDCRF{i}.model = model;
        subjectResultSHDCRF{i}.stats = stats;
        subjectResultSHDCRF{i}.ll = ll;
        subjectResultSHDCRF{i}.labels = labels;
        subjectResultSHDCRF{i}.result = result;
        %plotResult(result);
    end
end

diary off;

