loadDataSHDCRF;

% subject 1.

% 18 latent label features
% 24 window features
% 36 edge features
% -> 18 + 60 = 78 total

nbhiddenStates = 6;
nbfeatureStates = 4;
nbLabels = 3;

% Some parameters here for convenience
%   
% We can make a graphical representations of state transitions,
% show the most likely sequence of hidden states 
% Table of p(y|h) based on shared features:
%
%         y=0      y=1      y=2
%   
% h1    0.9931  0.006865  5.51e-05  
% h2    0.9878  0.01159  0.0005786  
% h3    0.005689  0.9634  0.03089  
% h4    0.02523  0.9646  0.01017  
% h5    0.01658  0.008882  0.9745  
% h6    0.08141  0.2655  0.6531 

% Success rates:
% CRF:      58.99
% LDCRF:    60.62
% SHDCR:    60.84

    
load SHDCRF-templates;
    
model = SHDCRFmodel1Template;
model.model.weights = [sf;wef];
model.model.nbStates = 6;

[ll, labels] = test(model, subjectData{1}.testSeqs, subjectData{1}.testLabels);
SHDCRFresult1 = getResult(ll{1,1}, labels{1,1});

load resLDCRF-s01-s02;
load resCRF;


% plot subplot
fprintf('Success rate CRF: %d/%d = %.2f\n', subjectResultCRF{1}.result.correctSamples, subjectResultCRF{1}.result.N, subjectResultCRF{1}.result.successRate);
fprintf('Success rate LDCRF: %d/%d = %.2f\n', subjectResultLDCRF{1}.result.correctSamples, subjectResultLDCRF{1}.result.N, subjectResultLDCRF{1}.result.successRate);
fprintf('Success rate SHDCRF: %d/%d = %.2f\n', SHDCRFresult1.correctSamples, SHDCRFresult1.N, SHDCRFresult1.successRate);

fs = 16;
Ns = size(SHDCRFresult1.labels, 2);
T = Ns/fs;
t = linspace(0, T, Ns);

figure(1);

subplot(3,1,1);
plot(t, subjectResultCRF{1}.result.labels, 'b--');
hold on;
plot(t, subjectResultCRF{1}.result.predictedLabels+0.01, 'r');
axis([0, T, -1, subjectResultCRF{1}.result.numClasses]);
title(sprintf('Subject 1\n CRF'));
legend('true labels', 'predicted labels');

subplot(3,1,2);
plot(t, subjectResultLDCRF{1}.result.labels, 'b--');
hold on;
plot(t, subjectResultLDCRF{1}.result.predictedLabels+0.01, 'r');
ylabel('Label');
axis([0, T, -1, subjectResultCRF{1}.result.numClasses]);
title('LDCRF');

subplot(3,1,3);
plot(t, SHDCRFresult1.labels, 'b--');
hold on;
plot(t, SHDCRFresult1.predictedLabels+0.01, 'r');
xlabel('Time [s]');
axis([0, T, -1, subjectResultCRF{1}.result.numClasses]);
title('SHDCRF');

