loadDataSHDCRF;

% subject 2.

% 18 latent label features
% 36 window features
% 36 edge features
% -> 18 + 72 = 90 total

nbhiddenStates = 6;
nbfeatureStates = 6;
nbLabels = 3;


% We can make a graphical representations of state transitions,
% show the most likely sequence of hidden states:
% h1-h3-h5-h2->

% Table of p(y|h) based on shared features:

%         y=0      y=1      y=2
%   
% h1    0.5568  0.1014  0.3418  
% h2    0.06865  0.8593  0.07202  
% h3    0.05697  0.8554  0.08767  
% h4    0.265  0.5418  0.1932  
% h5    0.0005267  0.265  0.7345  
% h6    0.0006392  0.2416  0.7577  

% Success rates:
% CRF:      71.20
% LDCRF:    69.04
% SHDCR:    74.42

    
load SHDCRF-templates;
    
model = SHDCRFmodel2Template;
model.model.weights = [sf;wef];
model.model.nbStates = 6;

[ll, labels] = test(model, subjectData{2}.testSeqs, subjectData{2}.testLabels);
SHDCRFresult2 = getResult(ll{1,1}, labels{1,1});


load resLDCRF-s01-s02;
load resCRF;


% plot subplot
fprintf('Success rate CRF: %d/%d = %.2f\n', subjectResultCRF{2}.result.correctSamples, subjectResultCRF{2}.result.N, subjectResultCRF{2}.result.successRate);
fprintf('Success rate LDCRF: %d/%d = %.2f\n', subjectResultLDCRF{2}.result.correctSamples, subjectResultLDCRF{2}.result.N, subjectResultLDCRF{2}.result.successRate);
fprintf('Success rate SHDCRF: %d/%d = %.2f\n', SHDCRFresult2.correctSamples, SHDCRFresult2.N, SHDCRFresult2.successRate);

fs = 16;
Ns = size(SHDCRFresult2.labels, 2);
T = Ns/fs;
t = linspace(0, T, Ns);

figure(1);

subplot(3,1,1);
plot(t, subjectResultCRF{2}.result.labels, 'b--');
hold on;
plot(t, subjectResultCRF{2}.result.predictedLabels+0.01, 'r');
axis([0, T, -1, subjectResultCRF{2}.result.numClasses]);
title(sprintf('Subject 2\n CRF'));
legend('true labels', 'predicted labels');

subplot(3,1,2);
plot(t, subjectResultLDCRF{2}.result.labels, 'b--');
hold on;
plot(t, subjectResultLDCRF{2}.result.predictedLabels+0.01, 'r');
ylabel('Label');
axis([0, T, -1, subjectResultCRF{2}.result.numClasses]);
title('LDCRF');

subplot(3,1,3);
plot(t, SHDCRFresult2.labels, 'b--');
hold on;
plot(t, SHDCRFresult2.predictedLabels+0.01, 'r');
xlabel('Time [s]');
axis([0, T, -1, subjectResultCRF{2}.result.numClasses]);
title('SHDCRF');

