loadDataSHDCRF;

% subject 3.

% 18 latent label features
% 12 window features
% 36 edge features
% -> 18 + 48 = 66 total

nbhiddenStates = 6;
nbfeatureStates = 2;
nbLabels = 3;


% We can make a graphical representations of state transitions
% Table of p(y|h) based on shared features



% We can make a graphical representations of state transitions,
% show the most likely sequence of hidden states 
% Table of p(y|h) based on shared features (it prints to stdout when model is tested):

%         y=0      y=1      y=2
%   
% h1    0.9079  0.07944  0.01263  
% h2    0.9746  0.01451  0.01086  
% h3    0.00727  0.0653  0.9274  
% h4    0.08775  0.7772  0.135  
% h5    0.2729  0.1062  0.6209  
% h6    0.533  0.01009  0.4569

% Success rates:
% CRF:      38.40
% LDCRF:    50.67
% SHDCR:    58.52


load SHDCRF-templates;
    
model = SHDCRFmodel3Template;
model.model.weights = [sf;wef];
model.model.nbStates = 6;

[ll, labels] = test(model, subjectData{3}.testSeqs, subjectData{3}.testLabels);
SHDCRFresult3 = getResult(ll{1,1}, labels{1,1});


load resLDCRF-s03;
load resCRF;


% plot subplot
fprintf('Success rate CRF: %d/%d = %.2f\n', subjectResultCRF{3}.result.correctSamples, subjectResultCRF{3}.result.N, subjectResultCRF{3}.result.successRate);
fprintf('Success rate LDCRF: %d/%d = %.2f\n', subjectResultLDCRF{3}.result.correctSamples, subjectResultLDCRF{3}.result.N, subjectResultLDCRF{3}.result.successRate);
fprintf('Success rate SHDCRF: %d/%d = %.2f\n', SHDCRFresult3.correctSamples, SHDCRFresult3.N, SHDCRFresult3.successRate);

fs = 16;
Ns = size(SHDCRFresult3.labels, 2);
T = Ns/fs;
t = linspace(0, T, Ns);

figure(1);

subplot(3,1,1);
plot(t, subjectResultCRF{3}.result.labels, 'b--');
hold on;
plot(t, subjectResultCRF{3}.result.predictedLabels+0.01, 'r');
axis([0, T, -1, subjectResultCRF{3}.result.numClasses]);
title(sprintf('Subject 3\n CRF'));
legend('true labels', 'predicted labels');

subplot(3,1,2);
plot(t, subjectResultLDCRF{3}.result.labels, 'b--');
hold on;
plot(t, subjectResultLDCRF{3}.result.predictedLabels+0.01, 'r');
ylabel('Label');
axis([0, T, -1, subjectResultCRF{3}.result.numClasses]);
title('LDCRF');

subplot(3,1,3);
plot(t, SHDCRFresult3.labels, 'b--');
hold on;
plot(t, SHDCRFresult3.predictedLabels+0.01, 'r');
xlabel('Time [s]');
axis([0, T, -1, subjectResultCRF{3}.result.numClasses]);
title('SHDCRF');

