
figure(1);

fs = 16;

Ns1 = size(SHDCRFresult1.labels, 2);
T1 = Ns1/fs;
t1 = linspace(0, T, Ns1);

Ns2 = size(SHDCRFresult2.labels, 2);
T2 = Ns2/fs;
t2 = linspace(0, T, Ns2);

Ns3 = size(SHDCRFresult3.labels, 2);
T3 = Ns3/fs;
t3 = linspace(0, T, Ns3);

% crfs , subject 1 2 3 
subplot(3,3,1);
plot(t1, subjectResultCRF{1}.result.labels, 'b--');
hold on;
plot(t1, subjectResultCRF{1}.result.predictedLabels+0.01, 'r');
axis([0, T1, -1, subjectResultCRF{1}.result.numClasses]);
ylabel('CRF');
title(sprintf('Subject 1'));
%legend('true labels', 'predicted labels');

subplot(3,3,2);
plot(t2, subjectResultCRF{2}.result.labels, 'b--');
hold on;
plot(t2, subjectResultCRF{2}.result.predictedLabels+0.01, 'r');
axis([0, T2, -1, subjectResultCRF{2}.result.numClasses]);
title(sprintf('Subject 2'));
%legend('true labels', 'predicted labels');


subplot(3,3,3);
plot(t3, subjectResultCRF{3}.result.labels, 'b--');
hold on;
plot(t3, subjectResultCRF{3}.result.predictedLabels+0.01, 'r');
axis([0, T3, -1, subjectResultCRF{3}.result.numClasses]);
title(sprintf('Subject 3'));
legend('true labels', 'predicted labels');

% LDCRFs
load resLDCRF-s01-s02;
subplot(3,3,4);
plot(t1, subjectResultLDCRF{1}.result.labels, 'b--');
hold on;
plot(t1, subjectResultLDCRF{1}.result.predictedLabels+0.01, 'r');
ylabel('LDCRF');
axis([0, T1, -1, subjectResultCRF{1}.result.numClasses]);
%title('LDCRF');

subplot(3,3,5);
plot(t2, subjectResultLDCRF{2}.result.labels, 'b--');
hold on;
plot(t2, subjectResultLDCRF{2}.result.predictedLabels+0.01, 'r');
%ylabel('Label');
axis([0, T2, -1, subjectResultCRF{2}.result.numClasses]);
%title('LDCRF');

load resLDCRF-s03;
subplot(3,3,6);
plot(t3, subjectResultLDCRF{3}.result.labels, 'b--');
hold on;
plot(t3, subjectResultLDCRF{3}.result.predictedLabels+0.01, 'r');
ylabel('Label');
axis([0, T3, -1, subjectResultCRF{3}.result.numClasses]);
%title('LDCRF');


% SHDCRF
subplot(3,3,7);
plot(t1, SHDCRFresult1.labels, 'b--');
hold on;
plot(t1, SHDCRFresult1.predictedLabels+0.01, 'r');
ylabel('SHDCRF');
axis([0, T1, -1, subjectResultCRF{1}.result.numClasses]);
%title('SHDCRF');

subplot(3,3,8);
plot(t2, SHDCRFresult2.labels, 'b--');
hold on;
plot(t2, SHDCRFresult2.predictedLabels+0.01, 'r');
%xlabel('Time [s]');
axis([0, T2, -1, subjectResultCRF{2}.result.numClasses]);
%title('SHDCRF');

subplot(3,3,9);
plot(t3, SHDCRFresult3.labels, 'b--');
hold on;
plot(t3, SHDCRFresult3.predictedLabels+0.01, 'r');
%xlabel('Time [s]');
axis([0, T3, -1, subjectResultCRF{3}.result.numClasses]);
%title('SHDCRF');
