function X = extractErrPs(trial, errps, chan_idx, T)
% Extract ErrP samples from [trial], channel [chan_idx], with length T.
% X has all errps stored as row vectors.

fs = 128;
Noffset = fs/4; % offset = -0.25 sec
Ns = round(fs*T);
Ntot = size(trial, 2);
X = zeros(length(errps)-1, Ns + Noffset);

for i=1:length(errps)
    n0 = floor(errps(i)*fs) - Noffset;
    nt = Noffset + n0 + Ns - 1;

    if nt <= Ntot
        chanraw = trial(chan_idx, n0:nt);
        chandata = chanraw - mean(chanraw);
        X(i,:) = chandata;
    end
end
