function plotTrialRaw(trial, errps, chan_idx, chan_label)

fs = 128;
Ns = size(trial, 2);
T = round(Ns / fs);
t = linspace(0, T, Ns);

chanraw = trial(chan_idx, :);
chandata = chanraw - mean(chanraw);

figure;
plot(t, chandata);
hold on;

for i=1:length(errps)
    errp_t = errps(i);
    errp_y = min(chandata):max(chandata);
    errp_x = ones(1,length(errp_y))*errp_t;
    plot(errp_x, errp_y, 'r-');
    hold on;
end

ylabel('Amplitude [uV]');
xlabel('Time [s]');
title(sprintf('Channel %s', chan_label));