function plotTrialRaw2(trial, errps, noerrps, chan_idx, chan_label)
% This include also all keystrokes that are not errps as green bars

fs = 128;
Ns = size(trial, 2);
T = round(Ns / fs);
t = linspace(0, T, Ns);

chanraw = trial(chan_idx, :);
chandata = chanraw - mean(chanraw);

figure;
plot(t, chandata);
hold on;

for i=1:length(errps)
    errp_t = errps(i);
    errp_y = min(chandata):max(chandata);
    errp_x = ones(1,length(errp_y))*errp_t;
    plot(errp_x, errp_y, 'r-');
    hold on;
end

for i=1:length(noerrps)
    noerrp_t = noerrps(i);
    noerrp_y = min(chandata):max(chandata);
    noerrp_x = ones(1,length(noerrp_y))*noerrp_t;
    plot(noerrp_x, noerrp_y, 'g-');
    hold on;
end

ylabel('Amplitude [uV]');
xlabel('Time [s]');
title(sprintf('Channel %s', chan_label));