figure;

fs = 128;
T = 1; % 1 second
Ns = round(fs*T);
Noffset = fs/4; % offset = -0.25 sec
chan_idx = 1; % F3
t = linspace(-0.25, T, Ns + Noffset);

j = 1;
for i=1:3
    X = extractSubjectErrPs(i, 'robot', chan_idx, T); % F3, 1 second
    errp_count = size(X, 1);
    Xavrg = smooth(mean(X));
    errp_y = -2:3;
    errp_x = zeros(1,length(errp_y));
    
    subplot(3,2,j);
    plot(t, Xavrg);
    hold on;
    plot(errp_x, errp_y, 'r-');
    axis([-0.25 1 -1.5 3]);
    ylabel('Amplitude [uV]');
    title(sprintf('Subject %d, UR5 setup. Grand average of %d ErrP segments', i, errp_count));
    
    X = extractSubjectErrPs(i, 'path', chan_idx, T); % F3, 1 second
    errp_count = size(X, 1);
    Xavrg = smooth(mean(X));
    errp_y = -2:3;
    errp_x = zeros(1,length(errp_y));
    
    subplot(3,2,j+1);
    plot(t, Xavrg);
    hold on;
    plot(errp_x, errp_y, 'r-');
    axis([-0.25 1 -1.5 3]);
    ylabel('Amplitude [uV]');
    title(sprintf('Subject %d, path setup. Grand average of %d ErrP segments', i, errp_count));
    
    j = j+2;
end

