#!/usr/bin/env python
# -*- coding: utf-8 -*-

import sys
from pylab import *
from scipy.io import loadmat

COLORS = ('b', 'g', 'r', 'c', 'm', 'y', 'k')
CHANNELS = ["F3", "FC5", "AF3", "F7", "T7", "P7", "O1",
            "O2", "P8",  "T8",  "F8", "AF4", "FC6", "F4"]


def plot_trial(figname, trial, errps):
    figure()
    t = [i/128.0 for i in range(len(trial))]
    plot(t, trial, 'b')
    plot(errps, [max(trial)]*len(errps), 'rx')

    xlabel('Time [s]')
    ylabel('Potential [uV]')
    title('%s' % figname)
    #legend(['EEG', 'ErrPs'])
    savefig('fig/errp/%s' % figname)


def plotErrP(filename, chan_idxs):
    try:
        mat = loadmat(filename)
    except Exception, e:
        print e
        return 1
    
    figprefix = filename.split('.mat')[0].split('/')[-1]
    trials = mat['data']['trial']
    errps = mat['errps'][0][::]
    for idx in chan_idxs:
        plot_trial(figprefix + '-%s' % CHANNELS[idx], trials[0][0][0][0][idx][::], errps)
    
    return 0

if __name__ == '__main__':
    try:
        f = sys.argv[1]
    except Exception:
        print "Usage: %s [mat-file]" % sys.argv[0]
        sys.exit(1)
    sys.exit(plotErrP(f, range(13)))

